;notepad like program 
;by gxm 08/05/03
;----  
.386
.model flat,stdcall
option casemap:none
;----
include windows.inc
include user32.inc
include kernel32.inc
include gdi32.inc
include comdlg32.inc
includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib
includelib comdlg32.lib
;----
ICO_MAIN equ 100
ICO_MAIN equ 100
IDM_MAIN equ 100
IDA_MAIN equ 100

IDM_NEW  equ 101
IDM_OPEN equ 102
IDM_SAVE equ 103
IDM_SAVEAS  equ 104
IDM_SETPAGE equ 105
IDM_PRINT   equ 106

IDM_EDIT equ 107

IDM_UNDO    equ 108
IDM_CUT     equ  109
IDM_PASTE   equ 110
IDM_COPY    equ 111
IDM_DEL     equ 112
IDM_FIND    equ 113
IDM_FINDNEXT equ 114
IDM_REPLACE  equ 115
IDM_GO       equ 116
IDM_AUTOCR   equ 117
IDM_FONT     equ 118
IDM_STATUS   equ 119
IDM_HELP     equ 120
IDM_ABOUT    equ 121
IDM_EXIT     equ 122
IDM_SELALL equ 123

IDM_DATE equ 124

MAX_BUFFER equ 32768

;---
.data
.const
  szFilter db "Text file(*.txt)",0,"*.txt",0,\
              "All Files",0,"*.*",0,0
  szDefFileName db "*.txt",0
  szDefExt db "txt",0
  szEditClassName db "Edit",0
  szClassName db "Notepad",0
  szInitCaption db "UnTitled - Notepad",0
  szInitFileName db "UnTitled",0
  szTimeFormat db "%hu:%hu %hu-%hu-%hu",0
  FINDMSGSTRING db "commdlg_FindReplace",0
  szMboxFormat db "File %s Have Change.",0DH,0AH,0DH,0AH,"Do you want to Save?",0
  szMboxCaption db "Notepad",0
  szCaptionTrial db "- Notepad",0
  szFileNew db 0,0
.data?
  hInst dd ?
  hWinMain dd ?
  hEdit dd ?
  hTimer dd ?
  szFileBuffer db MAX_BUFFER dup(?)
  bIsChange db ?
  idFindMsg dd ?
  stFR FINDREPLACE <>
  szReplaceWith db 80 dup(?)
  szBuffer db 80 dup(?)
  hFindText dd ?
  szFileName db 256 dup(?)
  hAccTable dd ?
  stDevMode DEVMODE <>
  stDevNames DEVNAMES <>
  IsSaved dd ? ;wether the file have been saved
  IsFileName dd ?;wether exist the file name.
;---
.code
;--
;every 1/3 second[300 ms] to monitor and set the notepad status
_Monitor proc 
  ;the IsSave
  ;invoke SendMessage,hEdit,EM_GETMODIFY,NULL,NULL
  ;Modified
  ;.if eax!=0
  ;  mov IsSaved,0
  ;.endif
  ret
_Monitor endp

;FilePath to Filename;from the _lpszFilePath--->_lpszFileName
_PathToName proc _lpszFilePath,_lpszFileName
  
  invoke lstrlen,_lpszFilePath
  ;first reach the last character
  mov esi,_lpszFilePath
  add esi,eax
  dec esi
  
  .while TRUE
    dec esi
    mov al,[esi]
    .break .if al=='\'
  .endw
  
  inc esi
  invoke lstrcpy,_lpszFileName,esi
  ret
_PathToName endp

;Get the FileName;ps:Untitled as the Init File Name
_GetFileName proc _lpsrcFileName,_lpdestFileName
  invoke lstrcmp,_lpsrcFileName,offset szInitFileName
  .if eax==0
    invoke lstrcpy,_lpdestFileName,_lpsrcFileName
  .else
    invoke _PathToName,_lpsrcFileName,_lpdestFileName
  .endif 
  ret
_GetFileName endp

_Init proc
  local @stRect:RECT
  
  invoke RegisterWindowMessage,offset FINDMSGSTRING
  mov idFindMsg,eax
  
  invoke GetClientRect,hWinMain,addr @stRect
  
  invoke CreateWindowEx,NULL,offset szEditClassName,NULL,WS_CHILD or WS_VISIBLE or ES_MULTILINE or ES_AUTOVSCROLL\
    or ES_AUTOHSCROLL,0,0,@stRect.right,@stRect.bottom,\
    hWinMain,IDM_EDIT,hInst,NULL
  mov hEdit,eax
  ;here to ensure the focus on Edit to avoid the Date-->Select All error.
  invoke SetFocus,hEdit
  
  invoke lstrcpy,offset szFileName,offset szInitFileName
  
  mov IsSaved,0
  mov IsFileName,0
  
  invoke SetTimer,NULL,NULL,300,offset _Monitor
  mov hTimer,eax
  
  ret
_Init endp

;ret=0 no error
;ret=1 cancel and error
_Open proc 
  local @stOF:OPENFILENAME
  local @hFile,@dwBytesRead
  local @szBuffer[300]:byte,@szFileName[256]:byte
  
  .if IsFileName==0
    invoke GetWindowText,hEdit,offset szFileBuffer,MAX_BUFFER
    .if eax!=0
      invoke wsprintf,addr @szBuffer,offset szMboxFormat,offset szInitFileName
      invoke MessageBox,NULL,addr @szBuffer,offset szMboxCaption,MB_YESNOCANCEL
      .if eax==IDYES
        call _Save
        .if eax==1
          invoke SetFocus,hEdit
          ret
        .endif
      .elseif eax==IDCANCEL
        ret
      .endif
    .endif
  .else 
    invoke SendMessage,hEdit,EM_GETMODIFY,NULL,NULL
    .if eax!=0
      invoke _GetFileName,offset szFileName,addr @szFileName
      invoke wsprintf,addr @szBuffer,offset szMboxFormat,addr @szFileName
      invoke MessageBox,NULL,addr @szBuffer,offset szMboxCaption,MB_YESNOCANCEL
      .if eax==IDYES
        call _Save
        .if eax==1
          invoke SetFocus,hEdit
          ret
        .endif
      .elseif eax==IDCANCEL
        ret
      .endif
    .endif
  .endif
      
    
  invoke RtlZeroMemory,addr @stOF,sizeof OPENFILENAME
  mov @stOF.lStructSize,sizeof OPENFILENAME
  push hWinMain
  pop @stOF.hwndOwner
  mov @stOF.lpstrFilter,offset szFilter
  mov @stOF.lpstrFile,offset szFileName
  mov @stOF.nMaxFile,MAX_PATH
  mov @stOF.Flags,OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST
  invoke GetOpenFileName,addr @stOF
  ;cancel or other error
  .if eax==0
    ret
  .endif
  invoke CreateFile,addr szFileName,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_WRITE or FILE_SHARE_READ,\
    NULL,OPEN_EXISTING,\
    FILE_ATTRIBUTE_NORMAL,NULL
  mov @hFile,eax
  
  invoke ReadFile,@hFile,offset szFileBuffer,MAX_BUFFER,addr @dwBytesRead,NULL
  invoke SetWindowText,hEdit,offset szFileBuffer
  
  invoke CloseHandle,@hFile
  invoke SetFocus,hEdit
  call _SetTitle

  ret
_Open endp
  
;ret==0 no error
;ret==1 user cancel the Save Dialog
;two Start method:Ctrl+S,and Save Dialog
_Save proc 
  local @stOF:OPENFILENAME
  local @hFile
  local @dwWriteBytes,@dwWrittenBytes
  local @szFileName[256]:byte
  ;File Name exist=1,not =0
  ;Saved=1,not Saved=0
  ;N E FileName
  .if IsFileName==0
    invoke lstrcpy,offset szFileName,offset szDefFileName
    
    invoke RtlZeroMemory,addr @stOF,sizeof @stOF
    mov @stOF.lStructSize,sizeof @stOF
    push hWinMain
    pop @stOF.hwndOwner
    mov @stOF.lpstrFilter,offset szFilter
    lea eax,szFileName
    mov @stOF.lpstrFile,eax
    mov @stOF.nMaxFile,MAX_PATH
    mov @stOF.Flags,OFN_PATHMUSTEXIST or OFN_OVERWRITEPROMPT
    mov @stOF.lpstrDefExt,offset szDefExt
    invoke GetSaveFileName,addr @stOF
    ;cancel or other error
    .if eax==0
      ;make the FileName to be right<---can be canceled means dialog turn out.
      invoke lstrcpy,offset szFileName,offset szInitFileName
      mov eax,1
      ret
    .endif
    ;E FileName
    mov IsFileName,1
  .endif
  ;not have been saved
  invoke SendMessage,hEdit,EM_GETMODIFY,NULL,NULL
  .if eax==0
    invoke CreateFile,offset szFileName,GENERIC_WRITE,FILE_SHARE_WRITE or FILE_SHARE_READ,NULL,CREATE_ALWAYS,\
      FILE_ATTRIBUTE_NORMAL,NULL
    mov @hFile,eax
    ;invoke SendMessage,hEdit,WM_GETTEXT,MAX_BUFFER,offset szFileBuffer
    invoke GetWindowText,hEdit,offset szFileBuffer,MAX_BUFFER
    mov @dwWriteBytes,eax
    invoke WriteFile,@hFile,addr szFileBuffer,@dwWriteBytes,addr @dwWrittenBytes,NULL
    invoke CloseHandle,@hFile
    ;Saved
    mov IsSaved,1
  .endif
  
  call _SetTitle
  ;invoke _PathToName,offset szFileName,addr @szFileName
  ;invoke MessageBox,NULL,addr @szFileName,0,0
  invoke SendMessage,hEdit,EM_SETMODIFY,FALSE,NULL
  invoke SetFocus,hEdit
  ret
  
_Save endp

_SetFont proc
  local @stCF:CHOOSEFONT,@stLogFont:LOGFONT
  
  invoke RtlZeroMemory,addr @stCF,sizeof CHOOSEFONT
  mov @stCF.lStructSize,sizeof CHOOSEFONT
  push hWinMain
  pop @stCF.hwndOwner
  mov @stCF.Flags,CF_SCREENFONTS
  lea eax,@stLogFont
  mov @stCF.lpLogFont,eax
  ;mov @stCF.rgbColors,Blue
  invoke ChooseFont,addr @stCF
  
  invoke CreateFontIndirect,addr @stLogFont
  invoke SendMessage,hEdit,WM_SETFONT,eax,FALSE
  
  ret
_SetFont endp

_AutoCr proc

_AutoCr endp

_PrintDate proc
  local @stTime:SYSTEMTIME
  local @szBuffer[50]:byte
  
  invoke GetLocalTime,addr @stTime
  
  movzx eax,@stTime.wHour
  movzx ebx,@stTime.wMinute
  movzx ecx,@stTime.wYear
  movzx edx,@stTime.wMonth
  movzx esi,@stTime.wDay
  invoke wsprintf,addr @szBuffer,offset szTimeFormat,eax,ebx,ecx,edx,esi
  
  invoke SendMessage,hEdit,EM_REPLACESEL,TRUE,addr @szBuffer
  
  ret
_PrintDate endp
  
_Find proc
  
  invoke RtlZeroMemory,offset stFR,sizeof FINDREPLACE
  
  mov stFR.lStructSize,sizeof FINDREPLACE
  push hWinMain
  pop stFR.hwndOwner
  mov stFR.Flags,FR_DOWN
  mov stFR.lpstrFindWhat,offset szBuffer
  mov stFR.wFindWhatLen,sizeof szBuffer
  invoke FindText,offset stFR
  mov hFindText,eax
  
  ret
_Find endp

_Replace proc
  
  invoke RtlZeroMemory,offset stFR,sizeof FINDREPLACE
  mov stFR.lStructSize,sizeof FINDREPLACE
  push hWinMain
  pop stFR.hwndOwner
  mov stFR.Flags,FR_NOWHOLEWORD
  mov stFR.lpstrReplaceWith,offset szReplaceWith
  mov stFR.wReplaceWithLen,80
  ;mov stFR.lpstrFindWhat,offset szFindWhat
  ;mov stFR.wFindWhatLen,80
  invoke ReplaceText,offset stFR
  
  ret
_Replace endp

_SetPage proc
  local @stPS:PAGESETUPDLG
  
  invoke RtlZeroMemory,addr @stPS,sizeof PAGESETUPDLG
  mov @stPS.lStructSize,sizeof PAGESETUPDLG
  push hWinMain
  pop @stPS.hwndOwner

  mov @stPS.rtMargin.top,2500
  mov @stPS.rtMargin.bottom,2500
  mov @stPS.rtMargin.left,2000
  mov @stPS.rtMargin.right,2000
  mov @stPS.hDevMode,offset stDevMode
  mov @stPS.hDevNames,offset stDevNames
  mov @stPS.Flags,PSD_MARGINS
  invoke PageSetupDlg,addr @stPS
  
  ret
_SetPage endp

_New proc
  local @szFileName[256]:byte,@szBuffer[300]:byte
  
  invoke lstrcmpi,offset szFileName,offset szFileName
  invoke SendMessage,hEdit,EM_GETMODIFY,NULL,NULL
  .if eax!=0
    mov IsSaved,0
  .else
    mov IsSaved,1
  .endif
  ;NOT SAVED
  .if IsSaved==0
    invoke _GetFileName,offset szFileName,addr @szFileName
    invoke wsprintf,addr @szBuffer,offset szMboxFormat,addr @szFileName
    invoke MessageBox,NULL,addr @szBuffer,offset szMboxCaption,MB_YESNOCANCEL
    .if eax==IDYES
      call _Save
      ;error
      .if eax==1
        invoke SetFocus,hEdit
        ret
      .endif
    .elseif eax==IDCANCEL 
      invoke SetFocus,hEdit
      ret
    .endif
  .endif
  
  invoke lstrcpy,offset szFileName,offset szInitFileName
  invoke SetWindowText,hEdit,szFileNew
  invoke SetFocus,hEdit
  ;in the New Window NO FILE NAME 
  mov IsFileName,0
  call _SetTitle
  ret
_New endp

_SaveAs proc
  mov IsFileName,0
  mov IsSaved,0
  call _Save
  ret
_SaveAs endp


_SetTitle proc
  local @szFileName[256]:byte
  
  invoke _GetFileName,offset szFileName,addr @szFileName
  invoke lstrcat,addr @szFileName,offset szCaptionTrial
  invoke SetWindowText,hWinMain,addr  @szFileName
  ret
_SetTitle endp

_Quit proc
  local @szFileName[256]:byte,@szBuffer[256]:byte
  
  invoke SendMessage,hEdit,EM_GETMODIFY,NULL,NULL
  ;Modified
  .if eax!=0
    invoke _GetFileName,offset szFileName,addr @szFileName
    invoke wsprintf,addr @szBuffer,offset szMboxFormat,addr @szFileName
    invoke MessageBox,NULL,addr @szBuffer,offset szMboxCaption,MB_YESNOCANCEL or MB_ICONWARNING
    .if eax==IDYES
      call _Save
    .elseif eax==IDCANCEL
      ret
    .endif
  .endif
  invoke KillTimer,hWinMain,hTimer
  invoke PostMessage,hWinMain,WM_QUIT,NULL,NULL
    
  ret
_Quit endp

_Print proc
  local @stPD:PRINTDLG
  
  invoke RtlZeroMemory,addr @stPD,sizeof PRINTDLG
  mov @stPD.lStructSize,sizeof PRINTDLG
  push hWinMain
  pop @stPD.hwndOwner
  mov @stPD.hDevMode,offset stDevMode
  mov @stPD.hDevNames,offset stDevNames
  ;mov @stPD.Flags,
  invoke PrintDlg,addr @stPD
  ret
_Print endp
  
    
_WndProc proc uses ebx esi edi hWnd,uMsg,wParam,lParam
  
  push hWnd
  pop hWinMain
  mov eax,idFindMsg
  .if uMsg==WM_CLOSE
    call _Quit
  .elseif uMsg==WM_CREATE
    call _Init
  .elseif uMsg==WM_COMMAND
    mov eax,wParam
    and eax,0000FFFFh
    .if eax==IDM_SAVE
      call _Save
    .elseif eax==IDM_OPEN
      call _Open
    .elseif eax==IDM_EXIT
      call _Quit
    .elseif eax==IDM_FONT
      call _SetFont
    .elseif eax==IDM_AUTOCR
      call _AutoCr
    .elseif eax==IDM_SELALL
      invoke SendMessage,hEdit,EM_SETSEL,0,-1
    .elseif eax==IDM_DATE
      call _PrintDate
    .elseif eax==IDM_FIND
      call _Find
    .elseif eax==IDM_REPLACE
      call _Replace
    .elseif eax==IDM_CUT
      invoke SendMessage,hEdit,WM_CUT,NULL,NULL
    .elseif eax==IDM_PASTE
      invoke SendMessage,hEdit,WM_PASTE,NULL,NULL
    .elseif eax==IDM_COPY 
      invoke SendMessage,hEdit,WM_COPY,NULL,NULL
    .elseif eax==IDM_DEL
      invoke MessageBox,NULL,NULL,NULL,NULL
      invoke SendMessage,hEdit,WM_CLEAR,NULL,NULL
    .elseif eax==IDM_UNDO
      invoke SendMessage,hEdit,WM_UNDO,NULL,NULL
    .elseif eax==IDM_SETPAGE
      call _SetPage
    .elseif eax==IDM_NEW
      call _New
    .elseif eax==IDM_SAVEAS
      call _SaveAs
    .elseif eax==IDM_PRINT
      call _Print
    .endif
  .elseif uMsg==eax
    invoke MessageBox,NULL,NULL,NULL,NULL
  .else
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
    ret
  .endif
  mov eax,TRUE
  
  ret
_WndProc endp

_WinMain proc
  local @stWndClassEx:WNDCLASSEX,@stMsg:MSG
  
  invoke LoadAccelerators,hInst,IDA_MAIN
  mov hAccTable,eax 
  invoke RtlZeroMemory,addr @stWndClassEx,sizeof WNDCLASSEX
  mov @stWndClassEx.lpszClassName,offset szClassName
  push hInst
  pop @stWndClassEx.hInstance
  mov @stWndClassEx.cbSize,sizeof WNDCLASSEX
  mov @stWndClassEx.lpfnWndProc,offset _WndProc
  mov @stWndClassEx.style,CS_VREDRAW or CS_HREDRAW
  invoke LoadIcon,hInst,ICO_MAIN
  mov @stWndClassEx.hIcon,eax
  mov @stWndClassEx.hIconSm,eax
  invoke GetStockObject,WHITE_BRUSH
  mov @stWndClassEx.hbrBackground,eax
  invoke LoadCursor,NULL,IDC_ARROW
  mov @stWndClassEx.hCursor,eax
  mov @stWndClassEx.lpszMenuName,IDM_MAIN
  
  invoke RegisterClassEx,addr @stWndClassEx
  
  invoke CreateWindowEx,WS_EX_WINDOWEDGE or WS_EX_CLIENTEDGE,offset szClassName,offset szInitCaption,\
    WS_OVERLAPPEDWINDOW or WS_BORDER,CW_USEDEFAULT,\
    CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInst,NULL
  
  mov hWinMain,eax
  
  invoke ShowWindow,hWinMain,SW_SHOWNORMAL
  invoke UpdateWindow,hWinMain
  
  .while TRUE
  invoke GetMessage,addr @stMsg,hWinMain,0,0
  .break .if eax==0
  invoke IsDialogMessage,hFindText,addr @stMsg
  .if eax==0
    invoke TranslateAccelerator,hWinMain,hAccTable,addr @stMsg
    .if eax==0
      invoke TranslateMessage,addr @stMsg
      invoke DispatchMessage,addr @stMsg
    .endif
  .endif
  .endw
  
  ret
_WinMain endp

start:
  invoke GetModuleHandle,NULL
  mov hInst,eax
  call _WinMain
  invoke ExitProcess,NULL
  end start
